/*                     __                                               *\
**     ________ ___   / /  ___      __ ____  Scala.js Test Suite        **
**    / __/ __// _ | / /  / _ | __ / // __/  (c) 2013, LAMP/EPFL        **
**  __\ \/ /__/ __ |/ /__/ __ |/_// /_\ \    http://scala-js.org/       **
** /____/\___/_/ |_/____/_/ | |__/ /____/                               **
**                          |/____/                                     **
\*                                                                      */
package org.scalajs.testsuite.javalib.lang

import org.scalajs.jasminetest.JasmineTest
import scala.scalajs.js

object CharacterTestOnJDK7 extends JasmineTest {

  describe("java.lang.Character on JDK7 or higher") {

    it("should provide isBmpCodePoint") {
      // 50 randomly chosen characters that produce true
      expect(Character.isBmpCodePoint('\u0120')).toBeTruthy
      expect(Character.isBmpCodePoint('\u0147')).toBeTruthy
      expect(Character.isBmpCodePoint('\u028E')).toBeTruthy
      expect(Character.isBmpCodePoint('\u0464')).toBeTruthy
      expect(Character.isBmpCodePoint('\u0DB8')).toBeTruthy
      expect(Character.isBmpCodePoint('\u1909')).toBeTruthy
      expect(Character.isBmpCodePoint('\u1F26')).toBeTruthy
      expect(Character.isBmpCodePoint('\u1F7E')).toBeTruthy
      expect(Character.isBmpCodePoint('\u2C64')).toBeTruthy
      expect(Character.isBmpCodePoint('\u353E')).toBeTruthy
      expect(Character.isBmpCodePoint('\u39DB')).toBeTruthy
      expect(Character.isBmpCodePoint('\u3E74')).toBeTruthy
      expect(Character.isBmpCodePoint('\u3F14')).toBeTruthy
      expect(Character.isBmpCodePoint('\u3FB3')).toBeTruthy
      expect(Character.isBmpCodePoint('\u4656')).toBeTruthy
      expect(Character.isBmpCodePoint('\u4824')).toBeTruthy
      expect(Character.isBmpCodePoint('\u488D')).toBeTruthy
      expect(Character.isBmpCodePoint('\u4C03')).toBeTruthy
      expect(Character.isBmpCodePoint('\u4D87')).toBeTruthy
      expect(Character.isBmpCodePoint('\u4F3E')).toBeTruthy
      expect(Character.isBmpCodePoint('\u570D')).toBeTruthy
      expect(Character.isBmpCodePoint('\u57CF')).toBeTruthy
      expect(Character.isBmpCodePoint('\u5A1E')).toBeTruthy
      expect(Character.isBmpCodePoint('\u5A3E')).toBeTruthy
      expect(Character.isBmpCodePoint('\u5C29')).toBeTruthy
      expect(Character.isBmpCodePoint('\u6082')).toBeTruthy
      expect(Character.isBmpCodePoint('\u6518')).toBeTruthy
      expect(Character.isBmpCodePoint('\u7202')).toBeTruthy
      expect(Character.isBmpCodePoint('\u7B3F')).toBeTruthy
      expect(Character.isBmpCodePoint('\u93F4')).toBeTruthy
      expect(Character.isBmpCodePoint('\u9812')).toBeTruthy
      expect(Character.isBmpCodePoint('\u986B')).toBeTruthy
      expect(Character.isBmpCodePoint('\uA228')).toBeTruthy
      expect(Character.isBmpCodePoint('\uB05E')).toBeTruthy
      expect(Character.isBmpCodePoint('\uB4DD')).toBeTruthy
      expect(Character.isBmpCodePoint('\uB4EB')).toBeTruthy
      expect(Character.isBmpCodePoint('\uB824')).toBeTruthy
      expect(Character.isBmpCodePoint('\uB8D4')).toBeTruthy
      expect(Character.isBmpCodePoint('\uBA9D')).toBeTruthy
      expect(Character.isBmpCodePoint('\uC33E')).toBeTruthy
      expect(Character.isBmpCodePoint('\uD0A4')).toBeTruthy
      expect(Character.isBmpCodePoint('\uD0D7')).toBeTruthy
      expect(Character.isBmpCodePoint('\uD596')).toBeTruthy
      expect(Character.isBmpCodePoint('\uDF06')).toBeTruthy
      expect(Character.isBmpCodePoint('\uE419')).toBeTruthy
      expect(Character.isBmpCodePoint('\uE66A')).toBeTruthy
      expect(Character.isBmpCodePoint('\uED6B')).toBeTruthy
      expect(Character.isBmpCodePoint('\uEE2A')).toBeTruthy
      expect(Character.isBmpCodePoint('\uF116')).toBeTruthy
      expect(Character.isBmpCodePoint('\uFC7E')).toBeTruthy

      // 50 randomly chosen characters that produce false
      expect(Character.isBmpCodePoint(104494)).toBeFalsy
      expect(Character.isBmpCodePoint(125793)).toBeFalsy
      expect(Character.isBmpCodePoint(131158)).toBeFalsy
      expect(Character.isBmpCodePoint(163501)).toBeFalsy
      expect(Character.isBmpCodePoint(182050)).toBeFalsy
      expect(Character.isBmpCodePoint(190085)).toBeFalsy
      expect(Character.isBmpCodePoint(195066)).toBeFalsy
      expect(Character.isBmpCodePoint(197399)).toBeFalsy
      expect(Character.isBmpCodePoint(212487)).toBeFalsy
      expect(Character.isBmpCodePoint(220872)).toBeFalsy
      expect(Character.isBmpCodePoint(228423)).toBeFalsy
      expect(Character.isBmpCodePoint(229980)).toBeFalsy
      expect(Character.isBmpCodePoint(231638)).toBeFalsy
      expect(Character.isBmpCodePoint(250644)).toBeFalsy
      expect(Character.isBmpCodePoint(251190)).toBeFalsy
      expect(Character.isBmpCodePoint(262467)).toBeFalsy
      expect(Character.isBmpCodePoint(278850)).toBeFalsy
      expect(Character.isBmpCodePoint(279865)).toBeFalsy
      expect(Character.isBmpCodePoint(282442)).toBeFalsy
      expect(Character.isBmpCodePoint(298662)).toBeFalsy
      expect(Character.isBmpCodePoint(304549)).toBeFalsy
      expect(Character.isBmpCodePoint(329478)).toBeFalsy
      expect(Character.isBmpCodePoint(425451)).toBeFalsy
      expect(Character.isBmpCodePoint(432483)).toBeFalsy
      expect(Character.isBmpCodePoint(459609)).toBeFalsy
      expect(Character.isBmpCodePoint(468002)).toBeFalsy
      expect(Character.isBmpCodePoint(481274)).toBeFalsy
      expect(Character.isBmpCodePoint(493980)).toBeFalsy
      expect(Character.isBmpCodePoint(504523)).toBeFalsy
      expect(Character.isBmpCodePoint(531036)).toBeFalsy
      expect(Character.isBmpCodePoint(544623)).toBeFalsy
      expect(Character.isBmpCodePoint(580236)).toBeFalsy
      expect(Character.isBmpCodePoint(604965)).toBeFalsy
      expect(Character.isBmpCodePoint(605557)).toBeFalsy
      expect(Character.isBmpCodePoint(608870)).toBeFalsy
      expect(Character.isBmpCodePoint(611891)).toBeFalsy
      expect(Character.isBmpCodePoint(631390)).toBeFalsy
      expect(Character.isBmpCodePoint(679492)).toBeFalsy
      expect(Character.isBmpCodePoint(694553)).toBeFalsy
      expect(Character.isBmpCodePoint(879975)).toBeFalsy
      expect(Character.isBmpCodePoint(926901)).toBeFalsy
      expect(Character.isBmpCodePoint(934288)).toBeFalsy
      expect(Character.isBmpCodePoint(951314)).toBeFalsy
      expect(Character.isBmpCodePoint(952297)).toBeFalsy
      expect(Character.isBmpCodePoint(965942)).toBeFalsy
      expect(Character.isBmpCodePoint(1003588)).toBeFalsy
      expect(Character.isBmpCodePoint(1005139)).toBeFalsy
      expect(Character.isBmpCodePoint(1043178)).toBeFalsy
      expect(Character.isBmpCodePoint(1075598)).toBeFalsy
      expect(Character.isBmpCodePoint(1097392)).toBeFalsy
    }

    it("should provide isAlphabetic") {
      // 50 randomly chosen characters that produce true
      expect(Character.isAlphabetic('\u04F8')).toBeTruthy
      expect(Character.isAlphabetic('\u05DB')).toBeTruthy
      expect(Character.isAlphabetic('\u1314')).toBeTruthy
      expect(Character.isAlphabetic('\u3515')).toBeTruthy
      expect(Character.isAlphabetic('\u3780')).toBeTruthy
      expect(Character.isAlphabetic('\u391C')).toBeTruthy
      expect(Character.isAlphabetic('\u3B06')).toBeTruthy
      expect(Character.isAlphabetic('\u3FEF')).toBeTruthy
      expect(Character.isAlphabetic('\u47CF')).toBeTruthy
      expect(Character.isAlphabetic('\u5076')).toBeTruthy
      expect(Character.isAlphabetic('\u5684')).toBeTruthy
      expect(Character.isAlphabetic('\u5773')).toBeTruthy
      expect(Character.isAlphabetic('\u591C')).toBeTruthy
      expect(Character.isAlphabetic('\u59A0')).toBeTruthy
      expect(Character.isAlphabetic('\u5B09')).toBeTruthy
      expect(Character.isAlphabetic('\u6775')).toBeTruthy
      expect(Character.isAlphabetic('\u7434')).toBeTruthy
      expect(Character.isAlphabetic('\u83FB')).toBeTruthy
      expect(Character.isAlphabetic('\u8761')).toBeTruthy
      expect(Character.isAlphabetic('\u8993')).toBeTruthy
      expect(Character.isAlphabetic('\u947A')).toBeTruthy
      expect(Character.isAlphabetic('\u98AB')).toBeTruthy
      expect(Character.isAlphabetic('\u98DA')).toBeTruthy
      expect(Character.isAlphabetic('\u9B44')).toBeTruthy
      expect(Character.isAlphabetic('\uADFF')).toBeTruthy
      expect(Character.isAlphabetic('\uC091')).toBeTruthy
      expect(Character.isAlphabetic('\uC43F')).toBeTruthy
      expect(Character.isAlphabetic('\uCB5D')).toBeTruthy
      expect(Character.isAlphabetic(133889)).toBeTruthy
      expect(Character.isAlphabetic(134427)).toBeTruthy
      expect(Character.isAlphabetic(134471)).toBeTruthy
      expect(Character.isAlphabetic(138909)).toBeTruthy
      expect(Character.isAlphabetic(139164)).toBeTruthy
      expect(Character.isAlphabetic(140493)).toBeTruthy
      expect(Character.isAlphabetic(148737)).toBeTruthy
      expect(Character.isAlphabetic(149345)).toBeTruthy
      expect(Character.isAlphabetic(151435)).toBeTruthy
      expect(Character.isAlphabetic(156857)).toBeTruthy
      expect(Character.isAlphabetic(158440)).toBeTruthy
      expect(Character.isAlphabetic(159937)).toBeTruthy
      expect(Character.isAlphabetic(159952)).toBeTruthy
      expect(Character.isAlphabetic(163859)).toBeTruthy
      expect(Character.isAlphabetic(166872)).toBeTruthy
      expect(Character.isAlphabetic(167076)).toBeTruthy
      expect(Character.isAlphabetic(168670)).toBeTruthy
      expect(Character.isAlphabetic(170390)).toBeTruthy
      expect(Character.isAlphabetic(170999)).toBeTruthy
      expect(Character.isAlphabetic(172036)).toBeTruthy
      expect(Character.isAlphabetic(173135)).toBeTruthy
      expect(Character.isAlphabetic(176898)).toBeTruthy

      // 50 randomly chosen characters that produce false
      expect(Character.isAlphabetic(1002047)).toBeFalsy
      expect(Character.isAlphabetic(1009593)).toBeFalsy
      expect(Character.isAlphabetic(1042564)).toBeFalsy
      expect(Character.isAlphabetic(1052587)).toBeFalsy
      expect(Character.isAlphabetic(1061824)).toBeFalsy
      expect(Character.isAlphabetic(1077156)).toBeFalsy
      expect(Character.isAlphabetic(1077935)).toBeFalsy
      expect(Character.isAlphabetic(108164)).toBeFalsy
      expect(Character.isAlphabetic(117071)).toBeFalsy
      expect(Character.isAlphabetic(180747)).toBeFalsy
      expect(Character.isAlphabetic(235975)).toBeFalsy
      expect(Character.isAlphabetic(256440)).toBeFalsy
      expect(Character.isAlphabetic(291721)).toBeFalsy
      expect(Character.isAlphabetic(313351)).toBeFalsy
      expect(Character.isAlphabetic(333549)).toBeFalsy
      expect(Character.isAlphabetic(353806)).toBeFalsy
      expect(Character.isAlphabetic(390947)).toBeFalsy
      expect(Character.isAlphabetic(400920)).toBeFalsy
      expect(Character.isAlphabetic(403305)).toBeFalsy
      expect(Character.isAlphabetic(417636)).toBeFalsy
      expect(Character.isAlphabetic(419085)).toBeFalsy
      expect(Character.isAlphabetic(443247)).toBeFalsy
      expect(Character.isAlphabetic(468248)).toBeFalsy
      expect(Character.isAlphabetic(485549)).toBeFalsy
      expect(Character.isAlphabetic(491917)).toBeFalsy
      expect(Character.isAlphabetic(511059)).toBeFalsy
      expect(Character.isAlphabetic(530210)).toBeFalsy
      expect(Character.isAlphabetic(569030)).toBeFalsy
      expect(Character.isAlphabetic(595429)).toBeFalsy
      expect(Character.isAlphabetic(607797)).toBeFalsy
      expect(Character.isAlphabetic(654788)).toBeFalsy
      expect(Character.isAlphabetic(660783)).toBeFalsy
      expect(Character.isAlphabetic(715383)).toBeFalsy
      expect(Character.isAlphabetic(752828)).toBeFalsy
      expect(Character.isAlphabetic(778169)).toBeFalsy
      expect(Character.isAlphabetic(781077)).toBeFalsy
      expect(Character.isAlphabetic(796535)).toBeFalsy
      expect(Character.isAlphabetic(819655)).toBeFalsy
      expect(Character.isAlphabetic(850895)).toBeFalsy
      expect(Character.isAlphabetic(866871)).toBeFalsy
      expect(Character.isAlphabetic(885354)).toBeFalsy
      expect(Character.isAlphabetic(908455)).toBeFalsy
      expect(Character.isAlphabetic(908635)).toBeFalsy
      expect(Character.isAlphabetic(924461)).toBeFalsy
      expect(Character.isAlphabetic(930019)).toBeFalsy
      expect(Character.isAlphabetic(948273)).toBeFalsy
      expect(Character.isAlphabetic(974041)).toBeFalsy
      expect(Character.isAlphabetic(977329)).toBeFalsy
      expect(Character.isAlphabetic(99202)).toBeFalsy
      expect(Character.isAlphabetic(993967)).toBeFalsy
    }

    it("should provide isIdeographic") {
      // 50 randomly chosen characters that produce true
      expect(Character.isIdeographic('\u388F')).toBeTruthy
      expect(Character.isIdeographic('\u4711')).toBeTruthy
      expect(Character.isIdeographic('\u527E')).toBeTruthy
      expect(Character.isIdeographic('\u5328')).toBeTruthy
      expect(Character.isIdeographic('\u5922')).toBeTruthy
      expect(Character.isIdeographic('\u5BA2')).toBeTruthy
      expect(Character.isIdeographic('\u5CAC')).toBeTruthy
      expect(Character.isIdeographic('\u65AF')).toBeTruthy
      expect(Character.isIdeographic('\u694C')).toBeTruthy
      expect(Character.isIdeographic('\u8068')).toBeTruthy
      expect(Character.isIdeographic('\u8C34')).toBeTruthy
      expect(Character.isIdeographic('\u8C9D')).toBeTruthy
      expect(Character.isIdeographic('\u8D3D')).toBeTruthy
      expect(Character.isIdeographic('\u9C62')).toBeTruthy
      expect(Character.isIdeographic(131994)).toBeTruthy
      expect(Character.isIdeographic(132852)).toBeTruthy
      expect(Character.isIdeographic(133501)).toBeTruthy
      expect(Character.isIdeographic(133591)).toBeTruthy
      expect(Character.isIdeographic(134246)).toBeTruthy
      expect(Character.isIdeographic(134328)).toBeTruthy
      expect(Character.isIdeographic(136431)).toBeTruthy
      expect(Character.isIdeographic(139867)).toBeTruthy
      expect(Character.isIdeographic(140528)).toBeTruthy
      expect(Character.isIdeographic(141460)).toBeTruthy
      expect(Character.isIdeographic(146741)).toBeTruthy
      expect(Character.isIdeographic(146759)).toBeTruthy
      expect(Character.isIdeographic(147539)).toBeTruthy
      expect(Character.isIdeographic(148459)).toBeTruthy
      expect(Character.isIdeographic(148689)).toBeTruthy
      expect(Character.isIdeographic(153593)).toBeTruthy
      expect(Character.isIdeographic(155694)).toBeTruthy
      expect(Character.isIdeographic(155818)).toBeTruthy
      expect(Character.isIdeographic(159961)).toBeTruthy
      expect(Character.isIdeographic(163220)).toBeTruthy
      expect(Character.isIdeographic(163464)).toBeTruthy
      expect(Character.isIdeographic(164167)).toBeTruthy
      expect(Character.isIdeographic(164197)).toBeTruthy
      expect(Character.isIdeographic(165508)).toBeTruthy
      expect(Character.isIdeographic(165973)).toBeTruthy
      expect(Character.isIdeographic(167743)).toBeTruthy
      expect(Character.isIdeographic(168585)).toBeTruthy
      expect(Character.isIdeographic(168758)).toBeTruthy
      expect(Character.isIdeographic(169731)).toBeTruthy
      expect(Character.isIdeographic(170186)).toBeTruthy
      expect(Character.isIdeographic(171240)).toBeTruthy
      expect(Character.isIdeographic(171988)).toBeTruthy
      expect(Character.isIdeographic(172886)).toBeTruthy
      expect(Character.isIdeographic(174236)).toBeTruthy
      expect(Character.isIdeographic(177495)).toBeTruthy
      expect(Character.isIdeographic(178011)).toBeTruthy

      // 50 randomly chosen characters that produce false
      expect(Character.isIdeographic('\uFB45')).toBeFalsy
      expect(Character.isIdeographic(1005864)).toBeFalsy
      expect(Character.isIdeographic(1006626)).toBeFalsy
      expect(Character.isIdeographic(1009910)).toBeFalsy
      expect(Character.isIdeographic(1032559)).toBeFalsy
      expect(Character.isIdeographic(1040837)).toBeFalsy
      expect(Character.isIdeographic(1070571)).toBeFalsy
      expect(Character.isIdeographic(107607)).toBeFalsy
      expect(Character.isIdeographic(1084694)).toBeFalsy
      expect(Character.isIdeographic(1098896)).toBeFalsy
      expect(Character.isIdeographic(121214)).toBeFalsy
      expect(Character.isIdeographic(193874)).toBeFalsy
      expect(Character.isIdeographic(208650)).toBeFalsy
      expect(Character.isIdeographic(253670)).toBeFalsy
      expect(Character.isIdeographic(266437)).toBeFalsy
      expect(Character.isIdeographic(268828)).toBeFalsy
      expect(Character.isIdeographic(269494)).toBeFalsy
      expect(Character.isIdeographic(278691)).toBeFalsy
      expect(Character.isIdeographic(282114)).toBeFalsy
      expect(Character.isIdeographic(294021)).toBeFalsy
      expect(Character.isIdeographic(334194)).toBeFalsy
      expect(Character.isIdeographic(351339)).toBeFalsy
      expect(Character.isIdeographic(356942)).toBeFalsy
      expect(Character.isIdeographic(388239)).toBeFalsy
      expect(Character.isIdeographic(398495)).toBeFalsy
      expect(Character.isIdeographic(424210)).toBeFalsy
      expect(Character.isIdeographic(437688)).toBeFalsy
      expect(Character.isIdeographic(454763)).toBeFalsy
      expect(Character.isIdeographic(499908)).toBeFalsy
      expect(Character.isIdeographic(543025)).toBeFalsy
      expect(Character.isIdeographic(544352)).toBeFalsy
      expect(Character.isIdeographic(552973)).toBeFalsy
      expect(Character.isIdeographic(557901)).toBeFalsy
      expect(Character.isIdeographic(570614)).toBeFalsy
      expect(Character.isIdeographic(607804)).toBeFalsy
      expect(Character.isIdeographic(639906)).toBeFalsy
      expect(Character.isIdeographic(659980)).toBeFalsy
      expect(Character.isIdeographic(668239)).toBeFalsy
      expect(Character.isIdeographic(711022)).toBeFalsy
      expect(Character.isIdeographic(765532)).toBeFalsy
      expect(Character.isIdeographic(776989)).toBeFalsy
      expect(Character.isIdeographic(777331)).toBeFalsy
      expect(Character.isIdeographic(812822)).toBeFalsy
      expect(Character.isIdeographic(815221)).toBeFalsy
      expect(Character.isIdeographic(828259)).toBeFalsy
      expect(Character.isIdeographic(82920)).toBeFalsy
      expect(Character.isIdeographic(869335)).toBeFalsy
      expect(Character.isIdeographic(912462)).toBeFalsy
      expect(Character.isIdeographic(958559)).toBeFalsy
      expect(Character.isIdeographic(999076)).toBeFalsy
    }

  }
}
